//objectDemo_student by Andrew Rose
//measure IP traffic in terms of number of packets (total size?) per IP/port/socket
//resource: https://shiffman.net/a2z/text-analysis/

//Part 1 - Analysis
//1.1: create a sockets object and a keys array for sorting the object
//1.2: loop thru packets
//1.3: if IP packet, determine if you are source or destination, 
//1.4: print socket you are communicating with (IP address + port of other cpu)
//1.5: add to socket object (set new to 1, increment existing)
//1.6: sort keys of sockets object by highest number of packets, store as keys array
//1.7: output sorted key-value pairs
//1.8: calculate % totals
//challenge: filter by ip and port separately, add layer 2 data (mac address)

//Extension: Visualization with BarGraph

var host = "000.000.000.000"; //put your IP address here - ifconfig
var sockets = {}; //1.1 obj {socket: # packets}
var keys = []; //array of sockets - can be sorted by # packets

function setup() {
  createFileInput(gotFile); //user must select valid wireshark JSON
}

//called whenever a file is selected
function gotFile(file) {
  loadJSON(file.data, parseJSON);
}

//called once JSON is loaded
function parseJSON(packets) {
  //reset variables
  sockets = {}
  keys = []

  //1.2 look at each packet i in data

    //create variables for:
        //layer
        //ip layer 
        //ip address of other computer
        //port number of other computer
        //socket = ip address + ":" + port
        
    //1.3 if there is an ip layer, identify if you are source or destination IP
    //determine protocol (TCP/UDP) and get the port used by other cpu
    //use other's IP address and port number to create a socket
    //otherwise label socket as "layer 2"
    
    
    //1.5 if socket is not a key of the object (first occurence)
      //add as key with a value of 1
      //add to keys array at same time
    //else
      //increment value of key by 1

  //stop looping thru packets
  
  //1.6 sort keys (sockets) by greatest # packets
  
  //display results
  //ip address : port# (# packets - ##.##%) //1.8
  
}